#include <stdio.h>
#include <math.h>
#include "c_n.h"
#include "c_6.h"

Cc_6::Cc_6(int *J,int N, double spin,int *neqp,int nneqp,int NNmax,int *AnzahlNN,int *NN,FILE *fp)
{
    Init(J,N,spin,neqp,nneqp,NNmax,AnzahlNN,NN,fp);
}

Cc_6::Cc_6()
{
    Init(0,0,0,0,0,0,0,0,0);
}

void Cc_6::berechnen(int write)
{
    double r=spin*(spin+1.0);
    for(int j=0;j<MAXORDER4;Ji[j]=0,j++);
    if(write==0)fprintf(fp,"\n6th order\n");
    // Fünffachbindung G23
    berechneGraph(23,-1.0/113400.0*r*r*(192-522*r-67*r*r+240*r*r*r+160*r*r*r*r),write);
    // Zweierkette mit Vierer- und Einfachbindung G24
    berechneGraph(24,-1.0/1944.0*r*r*r*(-3+6*r+4*r*r),write);
    // Zweierkette mit Drei- und Zweifachbindung G26
    berechneGraph(26,-1.0/972.0*r*r*r*(-3+3*r+2*r*r),write);
    // Stern mit Dreifachbindung G27
    berechneGraph(27,-1.0/972.0*r*r*r*r,write);
    // Dreieck mit Dreifachbindung G28
    berechneGraph(28,-1.0/2430.0*r*r*r*(-6+21*r+16*r*r),write);
    // Dreierkette mit Dreifachbindung in der Mitte G29
    berechneGraph(29,-1.0/4860.0*r*r*r*r*(3-8*r-8*r*r),write);
    // Dreierkette mit Dreifachbindung am Anfang G30
    berechneGraph(30,2.0/1215.0*r*r*r*r*(-1+r+r*r),write);
    // Stern mit 2 Doppelbindungen G33
    berechneGraph(33,-1.0/324.0*r*r*r*r,write);
    // Dreieck mit 2 Doppelbindungen G34
    berechneGraph(34,1.0/24300.0*r*r*r*(9-126*r-12*r*r+152*r*r*r),write);
    // Dreierkette mit Doppelbindung in der Mitte und am Anfang G35
    berechneGraph(35,-1.0/648.0*r*r*r*r,write);
    // Dreieck mit Doppelbindung und angehängter Einfachbindung G37
    berechneGraph(37,1.0/1620.0*r*r*r*r*(-3+8*r+8*r*r),write);
    // Dreieck mit angehängter Doppelbindung G38
    berechneGraph(38,-5.0/972.0*r*r*r*r,write);
    // G39
    berechneGraph(39,1.0/729.0*r*r*r*r*r,write);
    // Viereck mit einer Doppelbindung G42
    berechneGraph(42,1.0/2430.0*r*r*r*r*(-7+12*r+12*r*r),write);
    // Viererkette mit Doppelbindung innen G43
    berechneGraph(43,1.0/1458.0*r*r*r*r*r,write);
    // Dreierkette mit Doppelbindung an jedem Ende G44
    berechneGraph(44,-1.0/648.0*r*r*r*r,write);
    // Viererkette mit Doppelbindung am Anfang G45
    berechneGraph(45,1.0/486.0*r*r*r*r*r,write);
    // Dreieck mit 2 Einfachbindungen an einer Ecke G50
    berechneGraph(50,2.0/729.0*r*r*r*r*r,write);
    // Viereck mit Diagonale G51
    berechneGraph(51,1.0/1620.0*r*r*r*r*(-1+16*r+16*r*r),write);
    // Dreieck mit Zweierkette an einer Ecke G52
    berechneGraph(52,2.0/729.0*r*r*r*r*r,write);
    // Viereck mit Einfachbindung an einer Ecke G53
    berechneGraph(53,2.0/729.0*r*r*r*r*r,write);
    // Fünfeck G56
    berechneGraph(56,5.0/729.0*r*r*r*r*r,write);
    // Fünferkette G57
    berechneGraph(57,-2.0/729.0*r*r*r*r*r*r,write);

    if(write!=1)ausgabe((char *)"c6/N",Ji);
}
