#include <stdio.h>
#include <math.h>
#include "c_n.h"
#include "c_7.h"

Cc_7::Cc_7(int *J,int N, double spin,int *neqp,int nneqp,int NNmax,int *AnzahlNN,int *NN,FILE *fp)
{
    Init(J,N,spin,neqp,nneqp,NNmax,AnzahlNN,NN,fp);
}

Cc_7::Cc_7()
{
    Init(0,0,0,0,0,0,0,0,0);
}

void Cc_7::berechnen(int write)
{
    double r=spin*(spin+1.0);
    for(int j=0;j<MAXORDER4;Ji[j]=0,j++);
    if(write==0)fprintf(fp,"\n7th order\n");
    // G58 6fach-Bindung
    berechneGraph(58,-1.0/194400.0*r*r*(138.0-444.0*r+163.0*r*r+296.0*r*r*r+160.0*r*r*r*r),write);
    // G59 Zweierkette mit 4fach- und 2fach-Bindung
    berechneGraph(59,-1.0/64800.0*r*r*r*(-79.0+164.0*r+64.0*r*r),write);
    // G60 Dreieck mit 4fach-Bindung
    berechneGraph(60,1.0/340200.0*r*r*r*(393.0-1413.0*r-13.0*r*r+1200.0*r*r*r+800.0*r*r*r*r),write);
    // G62 Zweierkette mit 2 3fach-Bindungen
    berechneGraph(62,1.0/291600.0*r*r*r*(321.0-615.0*r-48.0*r*r+320.0*r*r*r+96.0*r*r*r*r),write);
    // G63 Dreieck mit 3fach- und 2fach-Bindung
    berechneGraph(63,1.0/291600.0*r*r*r*(45.0-621.0*r+408.0*r*r+1264.0*r*r*r+288.0*r*r*r*r),write);
    // G64 Dreick mit angehängter 3fach-Bindung
    berechneGraph(64,1.0/29160.0*r*r*r*r*(-51.0+48.0*r+32.0*r*r),write);
    // G65 Viereck mit 3fach-Bindung
    berechneGraph(65,1.0/9720.0*r*r*r*r*(-11.0+32.0*r+24.0*r*r),write);
    // G68
    berechneGraph(68,1.0/4860.0*r*r*r*r*(-13.0+2.0*r),write);
    // G69
    berechneGraph(69,1.0/19440.0*r*r*r*r*(-23.0+52.0*r+40.0*r*r),write);
    // G70 Dreieck mit 3 2fach-Bindungen
    berechneGraph(70,1.0/32400.0*r*r*r*(12.0-99.0*r+40.0*r*r+152.0*r*r*r),write);
    // G71
    berechneGraph(71,-41.0/38880.0*r*r*r*r,write);
    // G72 Viereck mit 2 Doppelbindungen nebeneinander
    berechneGraph(72,1.0/291600.0*r*r*r*r*(-201.0+624.0*r+48.0*r*r-608.0*r*r*r),write);
    // G74 Viereck mit Doppeldiagonale
    berechneGraph(74,1.0/19440.0*r*r*r*r*(-25.0+128.0*r+112.0*r*r),write);
    // G75 Viereck mit Doppelbindung und Diagonale
    berechneGraph(75,1.0/291600.0*r*r*r*r*(3.0+768.0*r-144.0*r*r-1216.0*r*r*r),write);
    // G76
    berechneGraph(76,1.0/19440.0*r*r*r*r*(-5.0+16.0*r+16.0*r*r),write);
    // G77
    berechneGraph(77,29.0/14580.0*r*r*r*r*r,write);
    // G79 Viereck mit 2 Doppelbindungen gegenüberliegend
    berechneGraph(79,1.0/4860.0*r*r*r*r*(-3.0+4.0*r+4.0*r*r),write);
    // G80
    berechneGraph(80,-1.0/4860.0*r*r*r*r*r*(-5.0+8.0*r+8.0*r*r),write);
    // G83
    berechneGraph(83,11.0/3645.0*r*r*r*r*r,write);
    // G84 Viereck mit 2 Diagonalen
    berechneGraph(84,1.0/4860.0*(r*r*r*r-8.0*r*r*r*r*r),write);
    // G86 Sechseck
    berechneGraph(86,-2.0/729.0*r*r*r*r*r*r,write);
    // G87 Zweierkette mit 5fach-Bindung
    berechneGraph(87,1.0/340200.0*r*r*r*(192.0-522.0*r-67.0*r*r+240.0*r*r*r+160.0*r*r*r*r),write);
    // G89
    berechneGraph(89,1.0/5832.0*r*r*r*r*(-3.0+6.0*r+4.0*r*r),write);
    // G90 Stern mit 4fach-Bindung
    berechneGraph(90,1.0/29160.0*r*r*r*r*(-9.0+12.0*r+8.0*r*r),write);
    // G91
    berechneGraph(91,1.0/4860.0*r*r*r*r*(-1.0+3.0*r+2.0*r*r),write);
    // G93 Stern mit 3fach- und 2fach-Bindung
    berechneGraph(93,1.0/29160.0*r*r*r*r*(-30.0+27.0*r+16.0*r*r),write);
    // G94 Dreieck mit 3fach-Bindung und angehängter Einzelbindung
    berechneGraph(94,1.0/14580.0*r*r*r*r*(-12.0+39.0*r+28.0*r*r),write);
    // G95
    berechneGraph(95,1.0/29160.0*r*r*r*r*(-18.0+27.0*r+20.0*r*r),write);
    // G96
    berechneGraph(96,1.0/14580.0*r*r*r*r*(-6.0+3.0*r+2.0*r*r),write);
    // G97
    berechneGraph(97,1.0/2430.0*r*r*r*r*(-1.0+r+r*r),write);
    // G100 Dreieck mit 3fach-Bindung und angehängter Einzelbindung
    berechneGraph(100,1.0/7290.0*r*r*r*r*r*(3.0+4.0*r),write);
    // G101
    berechneGraph(101,-2.0/3645.0*r*r*r*r*r*(-1.0+r+r*r),write);
    // G102
    berechneGraph(102,1.0/2916.0*r*r*r*r*r,write);
    // G104
    berechneGraph(104,-1.0/14580.0*r*r*r*r*r*(-3.0+8.0*r+8.0*r*r),write);
    // G108 Dreieck mit 2 2fach-Bindungen und angehängter Einzelbindung
    berechneGraph(108,1.0/4860.0*r*r*r*r*r*(3.0+4.0*r),write);
    // G109
    berechneGraph(109,5.0/2916.0*r*r*r*r*r,write);
    // G110
    berechneGraph(110,1.0/1458.0*r*r*r*r*r,write);
    // G111
    berechneGraph(111,1.0/972.0*r*r*r*r*r,write);
    // G112
    berechneGraph(112,-1.0/145800.0*r*r*r*r*(18.0-207.0*r+36.0*r*r+304.0*r*r*r),write);
    // G113
    berechneGraph(113,-1.0/7290.0*r*r*r*r*r*(-5.0+12.0*r+12.0*r*r),write);
    // G114
    berechneGraph(114,1.0/1944.0*r*r*r*r*r,write);
    // G115
    berechneGraph(115,1.0/5832.0*r*r*r*r*r,write);
    // G116
    berechneGraph(116,13.0/14580.0*r*r*r*r*r,write);
    // G117
    berechneGraph(117,1.0/1458.0*r*r*r*r*r,write);
    // G118
    berechneGraph(118,1.0/3645.0*r*r*r*r*r,write);
    // G119
    berechneGraph(119,1.0/14580.0*r*r*r*r*r,write);
    // G120
    berechneGraph(120,-1.0/4860.0*r*r*r*r*r*(-3.0+8.0*r+8.0*r*r),write);
    // G121
    berechneGraph(121,1.0/2916.0*r*r*r*r*r,write);
    // G122
    berechneGraph(122,1.0/2430.0*(r*r*r*r*r-8.0*r*r*r*r*r*r-8.0*r*r*r*r*r*r*r),write);
    // G123
    berechneGraph(123,-1.0/14580.0*r*r*r*r*r*(-5.0+24.0*r+24.0*r*r),write);
    // G125
    berechneGraph(125,-1.0/14580.0*r*r*r*r*r,write);
    // G126
    berechneGraph(126,1.0/2430.0*r*r*r*r*r,write);
    // G127
    berechneGraph(127,1.0/1944.0*r*r*r*r*r,write);
    // G128
    berechneGraph(128,1.0/2916.0*r*r*r*r*r,write);
    // G129
    berechneGraph(129,-1.0/4860.0*r*r*r*r*r,write);
    // G134
    berechneGraph(134,1.0/3645.0*r*r*r*r*r,write);
    // G135
    berechneGraph(135,1.0/5832.0*r*r*r*r*r,write);
    // G136
    berechneGraph(136,1.0/7290.0*r*r*r*r*r,write);
    // G139
    berechneGraph(139,-1.0/1458.0*r*r*r*r*r*r,write);
    // G140
    berechneGraph(140,-1.0/4374.0*r*r*r*r*r*r,write);
    // G141
    berechneGraph(141,-1.0/4374.0*r*r*r*r*r*r,write);
    // G143
    berechneGraph(143,-2.0/2187.0*r*r*r*r*r*r,write);
    // G144
    berechneGraph(144,-1.0/2187.0*r*r*r*r*r*r,write);
    // G145
    berechneGraph(145,-1.0/2187.0*r*r*r*r*r*r,write);
    // G150 Sechserette
    berechneGraph(150,2.0/2187.0*r*r*r*r*r*r*r,write);
    // G155
    berechneGraph(155,-1.0/4860.0*r*r*r*r*r*(-3.0+16.0*r+16.0*r*r),write);
    // G156
    berechneGraph(156,1.0/2430.0*(r*r*r*r*r-8.0*r*r*r*r*r*r-8.0*r*r*r*r*r*r*r),write);
    // G157
    berechneGraph(157,-2.0/2187.0*r*r*r*r*r*r,write);
    // G158
    berechneGraph(158,-2.0/2187.0*r*r*r*r*r*r,write);
    // G159
    berechneGraph(159,-2.0/2187.0*r*r*r*r*r*r,write);
    // G160
    berechneGraph(160,-2.0/2187.0*r*r*r*r*r*r,write);

    if(write!=1)ausgabe((char *)"c7/N",Ji);
}
