#include <stdio.h>
#include <math.h>
#include "c_n.h"
#include "e_5.h"

Ce_5::Ce_5(int *J,int N, double spin,int *neqp,int nneqp,int NNmax,int *AnzahlNN,int *NN,FILE *fp)
{
    Init(J,N,spin,neqp,nneqp,NNmax,AnzahlNN,NN,fp);
}

Ce_5::Ce_5()
{
    Init(0,0,0,0,0,0,0,0,0);
}

void Ce_5::berechnen(int write)
{
    double r=spin*(spin+1.0);
    for(int j=0;j<MAXORDER4;Ji[j]=0,j++);
    if(write==0)fprintf(fp,"\n5th order\n");
    // G58
    berechneGraph(58,-1.0/75600.0*r*r*(192.0-522.0*r-67.0*r*r+240.0*r*r*r+160.0*r*r*r*r),write);
    // G59
    berechneGraph(59,-1.0/2160.0*r*r*r*(-9.0+12.0*r+8.0*r*r),write);
    // G60
    berechneGraph(60,-1.0/180.0*r*r*r*(-1.0+3.0*r+2.0*r*r),write);
    // G62
    berechneGraph(62,-1.0/1080.0*r*r*r*(-4.0+r),write);
    // G63
    berechneGraph(63,-1.0/226800.0*r*r*r*r*(630.0+840.0*r),write);
    // G64
    berechneGraph(64,-1.0/108.0*r*r*r*r,write);
    // G65
    berechneGraph(65,-1.0/226800.0*r*r*r*r*(1260.0-3360.0*r-3360.0*r*r),write);
    // G68
    berechneGraph(68,-1.0/108.0*r*r*r*r,write);
    // G69
    berechneGraph(69,-1.0/216.0*r*r*r*r,write);
    // G70
    berechneGraph(70,-1.0/226800.0*r*r*r*(-378.0+3402.0*r-2016.0*r*r-6384.0*r*r*r),write);
    // G71
    berechneGraph(71,-1.0/270.0*r*r*r*r,write);
    // G72
    berechneGraph(72,-1.0/540.0*r*r*r*r,write);
    // G74
    berechneGraph(74,-1.0/226800.0*r*r*r*r*(2100.0-10080.0*r-10080.0*r*r),write);
    // G75
    berechneGraph(75,1.0/540.0*r*r*r*r,write);
    // G76
    berechneGraph(76,-1.0/540.0*r*r*r*r,write);
    // G77
    berechneGraph(77,1.0/81.0*r*r*r*r*r,write);
    // G79
    berechneGraph(79,-1.0/360.0*r*r*r*r,write);
    // G80
    berechneGraph(80,1.0/162.0*r*r*r*r*r,write);
    // G83
    berechneGraph(83,2.0/81.0*r*r*r*r*r,write);
    // G84
    berechneGraph(84,-1.0/540.0*r*r*r*r,write);
    // G86
    berechneGraph(86,-2.0/81.0*r*r*r*r*r*r,write);

    if(write!=1)ausgabe((char*)"e5/N",Ji);
}
