#include <stdio.h>
#include <math.h>
#include "c_n.h"
#include "e_6.h"

Ce_6::Ce_6(int *J,int N, double spin,int *neqp,int nneqp,int NNmax,int *AnzahlNN,int *NN,FILE *fp)
{
    Init(J,N,spin,neqp,nneqp,NNmax,AnzahlNN,NN,fp);
}

Ce_6::Ce_6()
{
    Init(0,0,0,0,0,0,0,0,0);
}

void Ce_6::berechnen(int write)
{
    double r=spin*(spin+1.0);
    for(int j=0;j<MAXORDER4;Ji[j]=0,j++);
    if(write==0)fprintf(fp,"\n6th order\n");
    // G161
    berechneGraph(161,-1.0/129600.0*r*r*(138.0-444.0*r+163.0*r*r+296.0*r*r*r+160.0*r*r*r*r),write);
    // G163
    berechneGraph(163,-7.0/97200.0*r*r*r*(-24.0+54.0*r+19.0*r*r),write);
    // G165
    berechneGraph(165,1.0/19440.0*r*r*r*(48.0-162.0*r+13.0*r*r+144.0*r*r*r+96.0*r*r*r*r),write);
    // G167
    berechneGraph(167,-7.0/129600.0*r*r*r*(-26.0+41.0*r+16.0*r*r),write);
    // G169
    berechneGraph(169,-7.0/388800*r*r*r*(3.0+27.0*r+52.0*r*r),write);
    // G173
    berechneGraph(173,7.0/194400.0*r*r*r*(9.0-123.0*r+144.0*r*r+320.0*r*r*r+96.0*r*r*r*r),write);
    // G174
    berechneGraph(174,7.0/19440.0*r*r*r*r*(-9.0+2.0*r),write);
    // G177
    berechneGraph(177,7.0/194400.0*r*r*r*(12.0-99.0*r+40.0*r*r+152.0*r*r*r),write);
    // G178
    berechneGraph(178,7.0/9720.0*r*r*r*r*(-4.0+11.0*r+8.0*r*r),write);
    // G181
    berechneGraph(181,-7.0/9720.0*r*r*r*r*(5.0-18.0*r-12.0*r*r),write);
    // G185
    berechneGraph(185,-7.0/4860.0*r*r*r*r,write);
    // G189
    berechneGraph(189,-7.0/19440.0*r*r*r*r*(-1.0+2.0*r),write);
    // G192
    berechneGraph(192,-7.0/19440.0*r*r*r*r*(1.0-11.0*r-12.0*r*r),write);
    // G194
    berechneGraph(194,7.0/19440.0*r*r*r*r*(-4.0+r),write);
    // G196
    berechneGraph(196,7.0/77760.0*r*r*r*r,write);
    // G199
    berechneGraph(199,7.0/1944.0*r*r*r*r*r,write);
    // G202
    berechneGraph(202,-7.0/38880.0*r*r*r*r*(-1.0+8.0*r),write);
    // G208
    berechneGraph(208,-7.0/6480.0*r*r*r*r,write);
    // G212
    berechneGraph(212,7.0/9720.0*r*r*r*r*r*(5.0-24.0*r-24.0*r*r),write);
    // G214
    berechneGraph(214,7.0/2430.0*r*r*r*r*r,write);
    // G218
    berechneGraph(218,7.0/9720.0*r*r*r*r*(1.0-r),write);
    // G220
    berechneGraph(220,7.0/9720.0*r*r*r*r*r,write);
    // G223
    berechneGraph(223,-7.0/194400*r*r*r*r*(31.0-304.0*r+192.0*r*r+608.0*r*r*r),write);
    // G226
    berechneGraph(226,7.0/19440.0*r*r*r*r*(-9.0+12.0*r+8.0*r*r),write);
    // G228
    berechneGraph(228,-7.0/12960.0*r*r*r*r,write);
    // G229
    berechneGraph(229,7.0/972.0*r*r*r*r*r,write);
    // G232
    berechneGraph(232,7.0/9720.0*r*r*r*r*(-1.0+4.0*r+4.0*r*r),write);
    // G233
    berechneGraph(233,7.0/19440.0*r*r*r*r,write);
    // G238
    berechneGraph(238,-7.0/1215.0*r*r*r*r*r*(-1.0+6.0*r+6.0*r*r),write);
    // G240
    berechneGraph(240,-7.0/9720.0*r*r*r*r*r,write);
    // G246
    berechneGraph(246,-7.0/14580.0*r*r*r*r*r,write);
    // G266
    berechneGraph(266,7.0/2916.0*r*r*r*r*r,write);
    // G276
    berechneGraph(276,7.0/4860.0*r*r*r*r*r,write);
    // G283
    berechneGraph(283,7.0/3240.0*r*r*r*r*(-1.0+3.0*r+2.0*r*r),write);
    // G285
    berechneGraph(285,7.0/19440.0*r*r*r*r*(-2.0+5.0*r+4.0*r*r),write);
    // G290
    berechneGraph(290,-7.0/15552.0*r*r*r*r,write);
    // G291
    berechneGraph(291,7.0/3888.0*r*r*r*r*r,write);
    // G300
    berechneGraph(300,7.0/38880.0*r*r*r*r*(-5.0+8.0*r+8.0*r*r),write);
    // G302
    berechneGraph(302,-7.0/9720.0*r*r*r*r*r,write);
    // G304
    berechneGraph(304,7.0/1944.0*r*r*r*r*r,write);
    // G306
    berechneGraph(306,7.0/5832.0*r*r*r*r*r,write);
    // G309
    berechneGraph(309,-7.0/729.0*r*r*r*r*r*r,write);
    // G313
    berechneGraph(313,7.0/29160.0*r*r*r*r*r,write);
    // G323
    berechneGraph(323,7.0/14580.0*r*r*r*r*r,write);
    // G333
    berechneGraph(333,7.0/9720.0*r*r*r*r*r*(3.0-8.0*r-8.0*r*r),write);
    // G336
    berechneGraph(336,7.0/9720.0*r*r*r*r*r,write);
    // G339
    berechneGraph(339,7.0/11664.0*r*r*r*r*r,write);
    // G344
    berechneGraph(344,-7.0/1458.0*r*r*r*r*r*r,write);
    // G360
    berechneGraph(360,-7.0/2916.0*r*r*r*r*r*r,write);
    // G372
    berechneGraph(372,7.0/729.0*r*r*r*r*r*r*r,write);

    if(write!=1)ausgabe((char *)"e6/N",Ji);
}
