#include <stdio.h>
#include <iostream>
#include <math.h>
#include <time.h>
#include "c_n.h"
#include "c_1.h"
#include "c_2.h"
#include "c_3.h"
#include "c_4.h"
#include "c_5.h"
#include "c_6.h"
#include "c_7.h"
#include "c_8.h"
#include "e_1.h"
#include "e_2.h"
#include "e_3.h"
#include "e_4.h"
#include "e_5.h"
#include "e_6.h"
#include "e_7.h"
#include "hte.h"

using namespace std;

CHTE::CHTE(char *system,double spin,FILE *fp)
{
    geladen=0;
    this->fp=fp;
    this->system=system;
    this->spin=spin;
    error=jladen();
    c1.Init(J,N,spin,neqp,nneqp,NNmax,AnzahlNN,NN,fp);
    c2.Init(J,N,spin,neqp,nneqp,NNmax,AnzahlNN,NN,fp);
    c3.Init(J,N,spin,neqp,nneqp,NNmax,AnzahlNN,NN,fp);
    c4.Init(J,N,spin,neqp,nneqp,NNmax,AnzahlNN,NN,fp);
    c5.Init(J,N,spin,neqp,nneqp,NNmax,AnzahlNN,NN,fp);
    c6.Init(J,N,spin,neqp,nneqp,NNmax,AnzahlNN,NN,fp);
    c7.Init(J,N,spin,neqp,nneqp,NNmax,AnzahlNN,NN,fp);
    c8.Init(J,N,spin,neqp,nneqp,NNmax,AnzahlNN,NN,fp);
    e1.Init(J,N,spin,neqp,nneqp,NNmax,AnzahlNN,NN,fp);
    e2.Init(J,N,spin,neqp,nneqp,NNmax,AnzahlNN,NN,fp);
    e3.Init(J,N,spin,neqp,nneqp,NNmax,AnzahlNN,NN,fp);
    e4.Init(J,N,spin,neqp,nneqp,NNmax,AnzahlNN,NN,fp);
    e5.Init(J,N,spin,neqp,nneqp,NNmax,AnzahlNN,NN,fp);
    e6.Init(J,N,spin,neqp,nneqp,NNmax,AnzahlNN,NN,fp);
    e7.Init(J,N,spin,neqp,nneqp,NNmax,AnzahlNN,NN,fp);
}

int CHTE::showerror()
{
    if(error==1)
        cout<<"Error: Can't read system file.\n";
    if(error==2)
        cout<<"Error: File is no regular system file.\n";
    return error;
}

CHTE::~CHTE()
{
    if(geladen==1)
    {
        delete[] J;
        delete[] neqp;
        delete[] AnzahlNN;
        delete[] NN;
    }
}

void CHTE::berechnen(int write)
{
    clock_t start;
    start=clock();
    if(write!=1)
    {
        fprintf(fp,"***********************************************************************\n");
        fprintf(fp,"*  High-temperature expansion of the susceptibility up to 8th order,  *\n");
        fprintf(fp,"*                  internal energy up to 7th order and                *\n");
        fprintf(fp,"*                     specific heat up to 8th order                   *\n");
        fprintf(fp,"***********************************************************************\n\n");
        fprintf(fp,"system file: %s\n",system);
        fprintf(fp,"spin       : %f\n\n",spin);
        fprintf(fp,"******************\n");
        fprintf(fp,"* Susceptibility *\n");
        fprintf(fp,"******************\n");
    }
    cout<<"calculating c1...\n";
    c1.berechnen(write);
    cout<<"finished\ncalculating c2...\n";
    c2.berechnen(write);
    cout<<"finished\ncalculating c3...\n";
    c3.berechnen(write);
    cout<<"finished\ncalculating c4...\n";
    c4.berechnen(write);
    cout<<"finished\ncalculating c5...\n";
    c5.berechnen(write);
    cout<<"finished\ncalculating c6...\n";
    c6.berechnen(write);
    cout<<"finished\ncalculating c7...\n";
    c7.berechnen(write);
    cout<<"finished\ncalculating c8...\n";
    c8.berechnen(write);
    cout<<"finished\ncalculating e1...\n";
    if(write!=1)
    {
        fprintf(fp,"\n*******************\n");
        fprintf(fp,"* Internal Energy *\n");
        fprintf(fp,"*******************\n");
    }
    e1.berechnen(write);
    cout<<"finished\ncalculating e2...\n";
    e2.berechnen(write);
    cout<<"finished\ncalculating e3...\n";
    e3.berechnen(write);
    cout<<"finished\ncalculating e4...\n";
    e4.berechnen(write);
    cout<<"finished\ncalculating e5...\n";
    e5.berechnen(write);
    cout<<"finished\ncalculating e6...\n";
    e6.berechnen(write);
    cout<<"finished\ncalculating e7...\n";
    e7.berechnen(write);
    cout<<"finished\n";
    if(write!=1)
    {
        fprintf(fp,"\n*****************\n");
        fprintf(fp,"* Specific Heat *\n");
        fprintf(fp,"*****************\n");
        e1.specheat(2);
        e2.specheat(3);
        e3.specheat(4);
        e4.specheat(5);
        e5.specheat(6);
        e6.specheat(7);
        e7.specheat(8);
    }
    cout<<(clock()-start)/(double)CLOCKS_PER_SEC<<"sec\n";
}

int CHTE::jladen()
{
    FILE *fpsys;
    char zeile[1024];
    int test1,test2,test3,bindungen1,bindungen2,test4;
    char para1[10];
    fpsys=fopen(system,"r");
    if(fpsys==NULL)
        return 1;
    do fgets(zeile,1024,fpsys);while(zeile[0]=='#');
    if(sscanf(zeile,"%d %d %d\n",&N,&bindungen1,&test4)!=3)
        return 2;
    nneqp=test4;
    J=new int[N*N];
    neqp=new int[test4];
    for(int i=0;i<N;i++)
        for(int j=0;j<N;j++)
            J[i+N*j]=0;
    fgets(zeile,1024,fpsys);
    for(test4=0;;test4++)
    {
        fgets(zeile,1024,fpsys);
        if(zeile[0]=='#')
            break;
        sscanf(zeile,"%d\n",&test1);
        if(test4<nneqp)
            neqp[test4]=test1;
    }
    for(bindungen2=0;;bindungen2++)
    {
        fgets(zeile,1024,fpsys);
        if(zeile[0]=='#')
            break;
        sscanf(zeile,"%d %d %d %s\n",&test1,&test2,&test3,para1);
        if(test2>=N || test3>=N)
        {
            cout<<"bond "<<test1<<": spinnumber out of system.\n";
            return 2;
        }
        if(para1[1]=='1')
            J[test2+N*test3]=J[test3+N*test2]=2;
        else if(para1[1]=='2')
            J[test2+N*test3]=J[test3+N*test2]=3;
        else if(para1[1]=='3')
            J[test2+N*test3]=J[test3+N*test2]=5;
        else if(para1[1]=='4')
            J[test2+N*test3]=J[test3+N*test2]=7;
    }
    fclose(fpsys);
    if(test4!=nneqp)
    {
        cout<<"system file warning:\n";
        cout<<"    number of nonequivalent points set in line 4: "<<nneqp<<"\n";
        cout<<"    number of nonequivalent points read from file: "<<test4<<"\n";
        if(nneqp>test4)
        {
            nneqp=test4;
            cout<<"number of nonequivalent points set to "<<nneqp<<"\n";
        }
        else
            cout<<"number of nonequivalent points set to "<<nneqp<<"\n";
    }
    if(bindungen1!=bindungen2)
    {
        cout<<"system file warning:\n";
        cout<<"    number of bonds set in line 4: "<<bindungen1<<"\n";
        cout<<"    number of bonds read from file: "<<bindungen2<<"\n";
    }
    NNmax=0;
    for(int i=0;i<nneqp;i++)
    {
        for(int j=0,test1=0;j<N;j++)
        {
            if(J[neqp[i]+N*j]!=0)
                test1++;
            if(test1>NNmax)
                NNmax=test1;
        }
    }
    AnzahlNN=new int[N];
    NN=new int[N*NNmax];
    for(int i=0;i<N;i++)
    {
        AnzahlNN[i]=0;
        for(int j=0;j<N;j++)
            if(J[i+N*j]!=0)
                AnzahlNN[i]++;
        test1=0;
        for(int j=0;j<N && test1<NNmax;j++)
        {
            if(J[i+N*j]!=0)
            {
                NN[i*NNmax+test1]=j;
                test1++;
            }
        }
    }
    geladen=1;
    return 0;
}

void CHTE::graph(double ende,double intervall,double j1,double j2,double j3,double j4)
{
    double chi,chip,U,C,b,Cp;
    double tc1,tc2,tc3,tc4,tc5,tc6,tc7,tc8,te1,te2,te3,te4,te5,te6,te7,td2,td3,td4,td5,td6,td7,td8;
    double a1,a2,a3,a4,b0,b1,b2,b3,b4,m2,m3,m4,n1,n2,n3,n4;
    tc1=c1.punkt();
    tc2=c2.punkt(j1,j2,j3,j4);
    tc3=c3.punkt(j1,j2,j3,j4);
    tc4=c4.punkt(j1,j2,j3,j4);
    tc5=c5.punkt(j1,j2,j3,j4);
    tc6=c6.punkt(j1,j2,j3,j4);
    tc7=c7.punkt(j1,j2,j3,j4);
    tc8=c8.punkt(j1,j2,j3,j4);
    te1=e1.punkt(j1,j2,j3,j4);
    te2=e2.punkt(j1,j2,j3,j4);
    te3=e3.punkt(j1,j2,j3,j4);
    te4=e4.punkt(j1,j2,j3,j4);
    te5=e5.punkt(j1,j2,j3,j4);
    te6=e6.punkt(j1,j2,j3,j4);
    te7=e7.punkt(j1,j2,j3,j4);
    td2=-te1;
    td3=-2*te2;
    td4=-3*te3;
    td5=-4*te4;
    td6=-5*te5;
    td7=-6*te6;
    td8=-7*te7;
    a1=tc1;
    a2=(-(tc2*pow(tc4,4))+3*tc2*tc3*pow(tc4,2)*tc5+tc1*pow(tc4,3)*tc5-tc2*pow(tc3,2)*pow(tc5,2)-2*pow(tc2,2)*tc4*pow(tc5,2)-2*tc1*tc3*tc4*pow(tc5,2)+2*tc1*tc2*pow(tc5,3)-2*tc2*pow(tc3,2)*tc4*tc6+2*pow(tc2,2)*pow(tc4,2)*tc6-tc1*tc3*pow(tc4,2)*tc6
        +2*pow(tc2,2)*tc3*tc5*tc6+2*tc1*pow(tc3,2)*tc5*tc6-2*tc1*tc2*tc4*tc5*tc6-pow(tc1,2)*pow(tc5,2)*tc6-pow(tc2,3)*pow(tc6,2)+pow(tc1,2)*tc4*pow(tc6,2)+tc2*pow(tc3,3)*tc7-2*pow(tc2,2)*tc3*tc4*tc7+tc1*pow(tc3,2)*tc4*tc7+pow(tc2,3)*tc5*tc7-2*tc1*tc2*tc3*tc5*tc7
        +pow(tc1,2)*tc4*tc5*tc7+tc1*pow(tc2,2)*tc6*tc7-pow(tc1,2)*tc3*tc6*tc7-tc1*pow(tc3,3)*tc8+2*tc1*tc2*tc3*tc4*tc8-pow(tc1,2)*pow(tc4,2)*tc8-tc1*pow(tc2,2)*tc5*tc8+pow(tc1,2)*tc3*tc5*tc8)/(-pow(tc4,4)+3*tc3*pow(tc4,2)*tc5-pow(tc3,2)*pow(tc5,2)
        -2*tc2*tc4*pow(tc5,2)+tc1*pow(tc5,3)-2*pow(tc3,2)*tc4*tc6+2*tc2*pow(tc4,2)*tc6+2*tc2*tc3*tc5*tc6-2*tc1*tc4*tc5*tc6-pow(tc2,2)*pow(tc6,2)+tc1*tc3*pow(tc6,2)+pow(tc3,3)*tc7-2*tc2*tc3*tc4*tc7+tc1*pow(tc4,2)*tc7+pow(tc2,2)*tc5*tc7-tc1*tc3*tc5*tc7);
    a3=(-(tc3*pow(tc4,4))+3*pow(tc3,2)*pow(tc4,2)*tc5+tc2*pow(tc4,3)*tc5-pow(tc3,3)*pow(tc5,2)-4*tc2*tc3*tc4*pow(tc5,2)-tc1*pow(tc4,2)*pow(tc5,2)+pow(tc2,2)*pow(tc5,3)+2*tc1*tc3*pow(tc5,3)-2*pow(tc3,3)*tc4*tc6+tc2*tc3*pow(tc4,2)*tc6+tc1*pow(tc4,3)*tc6
        +4*tc2*pow(tc3,2)*tc5*tc6-2*tc1*tc3*tc4*tc5*tc6-2*tc1*tc2*pow(tc5,2)*tc6-2*pow(tc2,2)*tc3*pow(tc6,2)+tc1*pow(tc3,2)*pow(tc6,2)+pow(tc1,2)*tc5*pow(tc6,2)+pow(tc3,4)*tc7-tc2*pow(tc3,2)*tc4*tc7-pow(tc2,2)*pow(tc4,2)*tc7-2*tc1*pow(tc3,2)*tc5*tc7
        +4*tc1*tc2*tc4*tc5*tc7-pow(tc1,2)*pow(tc5,2)*tc7+pow(tc2,3)*tc6*tc7-pow(tc1,2)*tc4*tc6*tc7-tc1*pow(tc2,2)*pow(tc7,2)+pow(tc1,2)*tc3*pow(tc7,2)-tc2*pow(tc3,3)*tc8+2*pow(tc2,2)*tc3*tc4*tc8+tc1*pow(tc3,2)*tc4*tc8-2*tc1*tc2*pow(tc4,2)*tc8-pow(tc2,3)*tc5*tc8
        +pow(tc1,2)*tc4*tc5*tc8+tc1*pow(tc2,2)*tc6*tc8-pow(tc1,2)*tc3*tc6*tc8)/(-pow(tc4,4)+3*tc3*pow(tc4,2)*tc5-pow(tc3,2)*pow(tc5,2)-2*tc2*tc4*pow(tc5,2)+tc1*pow(tc5,3)-2*pow(tc3,2)*tc4*tc6+2*tc2*pow(tc4,2)*tc6+2*tc2*tc3*tc5*tc6-2*tc1*tc4*tc5*tc6
        -pow(tc2,2)*pow(tc6,2)+tc1*tc3*pow(tc6,2)+pow(tc3,3)*tc7-2*tc2*tc3*tc4*tc7+tc1*pow(tc4,2)*tc7+pow(tc2,2)*tc5*tc7-tc1*tc3*tc5*tc7);
    a4=(pow(tc4,5)-4*tc3*pow(tc4,3)*tc5+3*pow(tc3,2)*tc4*pow(tc5,2)+3*tc2*pow(tc4,2)*pow(tc5,2)-2*tc2*tc3*pow(tc5,3)-2*tc1*tc4*pow(tc5,3)+3*pow(tc3,2)*pow(tc4,2)*tc6-3*tc2*pow(tc4,3)*tc6-2*pow(tc3,3)*tc5*tc6-2*tc2*tc3*tc4*tc5*tc6+4*tc1*pow(tc4,2)*tc5*tc6
        +pow(tc2,2)*pow(tc5,2)*tc6+2*tc1*tc3*pow(tc5,2)*tc6+tc2*pow(tc3,2)*pow(tc6,2)+2*pow(tc2,2)*tc4*pow(tc6,2)-4*tc1*tc3*tc4*pow(tc6,2)-2*tc1*tc2*tc5*pow(tc6,2)+pow(tc1,2)*pow(tc6,3)-2*pow(tc3,3)*tc4*tc7+4*tc2*tc3*pow(tc4,2)*tc7-2*tc1*pow(tc4,3)*tc7
        +2*tc2*pow(tc3,2)*tc5*tc7-4*pow(tc2,2)*tc4*tc5*tc7+2*tc1*tc2*pow(tc5,2)*tc7-2*pow(tc2,2)*tc3*tc6*tc7+2*tc1*pow(tc3,2)*tc6*tc7+2*tc1*tc2*tc4*tc6*tc7-2*pow(tc1,2)*tc5*tc6*tc7+pow(tc2,3)*pow(tc7,2)-2*tc1*tc2*tc3*pow(tc7,2)+pow(tc1,2)*tc4*pow(tc7,2)
        +pow(tc3,4)*tc8-3*tc2*pow(tc3,2)*tc4*tc8+pow(tc2,2)*pow(tc4,2)*tc8+2*tc1*tc3*pow(tc4,2)*tc8+2*pow(tc2,2)*tc3*tc5*tc8-2*tc1*pow(tc3,2)*tc5*tc8-2*tc1*tc2*tc4*tc5*tc8+pow(tc1,2)*pow(tc5,2)*tc8-pow(tc2,3)*tc6*tc8+2*tc1*tc2*tc3*tc6*tc8-pow(tc1,2)*tc4*tc6*tc8)
        /(pow(tc4,4)-3*tc3*pow(tc4,2)*tc5+pow(tc3,2)*pow(tc5,2)+2*tc2*tc4*pow(tc5,2)-tc1*pow(tc5,3)+2*pow(tc3,2)*tc4*tc6-2*tc2*pow(tc4,2)*tc6-2*tc2*tc3*tc5*tc6+2*tc1*tc4*tc5*tc6+pow(tc2,2)*pow(tc6,2)-tc1*tc3*pow(tc6,2)-pow(tc3,3)*tc7+2*tc2*tc3*tc4*tc7
        -tc1*pow(tc4,2)*tc7-pow(tc2,2)*tc5*tc7+tc1*tc3*tc5*tc7);
    b1=(-(pow(tc4,3)*tc5)+2*tc3*tc4*pow(tc5,2)-tc2*pow(tc5,3)+tc3*pow(tc4,2)*tc6-2*pow(tc3,2)*tc5*tc6+tc1*pow(tc5,2)*tc6+tc2*tc3*pow(tc6,2)-tc1*tc4*pow(tc6,2)-pow(tc3,2)*tc4*tc7+tc2*pow(tc4,2)*tc7+tc2*tc3*tc5*tc7-tc1*tc4*tc5*tc7-pow(tc2,2)*tc6*tc7
        +tc1*tc3*tc6*tc7+pow(tc3,3)*tc8-2*tc2*tc3*tc4*tc8+tc1*pow(tc4,2)*tc8+pow(tc2,2)*tc5*tc8-tc1*tc3*tc5*tc8)/(pow(tc4,4)-3*tc3*pow(tc4,2)*tc5+pow(tc3,2)*pow(tc5,2)+2*tc2*tc4*pow(tc5,2)-tc1*pow(tc5,3)+2*pow(tc3,2)*tc4*tc6-2*tc2*pow(tc4,2)*tc6-2*tc2*tc3*tc5*tc6
        +2*tc1*tc4*tc5*tc6+pow(tc2,2)*pow(tc6,2)-tc1*tc3*pow(tc6,2)-pow(tc3,3)*tc7+2*tc2*tc3*tc4*tc7-tc1*pow(tc4,2)*tc7-pow(tc2,2)*tc5*tc7+tc1*tc3*tc5*tc7);
    b2=(-(pow(tc4,2)*pow(tc5,2))+tc3*pow(tc5,3)+pow(tc4,3)*tc6-tc2*pow(tc5,2)*tc6-tc2*tc4*pow(tc6,2)+tc1*tc5*pow(tc6,2)-tc3*pow(tc4,2)*tc7-pow(tc3,2)*tc5*tc7+3*tc2*tc4*tc5*tc7-tc1*pow(tc5,2)*tc7+tc2*tc3*tc6*tc7-tc1*tc4*tc6*tc7-pow(tc2,2)*pow(tc7,2)
        +tc1*tc3*pow(tc7,2)+pow(tc3,2)*tc4*tc8-tc2*pow(tc4,2)*tc8-tc2*tc3*tc5*tc8+tc1*tc4*tc5*tc8+pow(tc2,2)*tc6*tc8-tc1*tc3*tc6*tc8)/(-pow(tc4,4)+3*tc3*pow(tc4,2)*tc5-pow(tc3,2)*pow(tc5,2)-2*tc2*tc4*pow(tc5,2)+tc1*pow(tc5,3)-2*pow(tc3,2)*tc4*tc6
        +2*tc2*pow(tc4,2)*tc6+2*tc2*tc3*tc5*tc6-2*tc1*tc4*tc5*tc6-pow(tc2,2)*pow(tc6,2)+tc1*tc3*pow(tc6,2)+pow(tc3,3)*tc7-2*tc2*tc3*tc4*tc7+tc1*pow(tc4,2)*tc7+pow(tc2,2)*tc5*tc7-tc1*tc3*tc5*tc7);
    b3=(tc4*pow(tc5,3)-2*pow(tc4,2)*tc5*tc6-tc3*pow(tc5,2)*tc6+2*tc3*tc4*pow(tc6,2)+tc2*tc5*pow(tc6,2)-tc1*pow(tc6,3)+pow(tc4,3)*tc7-tc2*pow(tc5,2)*tc7-pow(tc3,2)*tc6*tc7-tc2*tc4*tc6*tc7+2*tc1*tc5*tc6*tc7+tc2*tc3*pow(tc7,2)-tc1*tc4*pow(tc7,2)-tc3*pow(tc4,2)*tc8
        +pow(tc3,2)*tc5*tc8+tc2*tc4*tc5*tc8-tc1*pow(tc5,2)*tc8-tc2*tc3*tc6*tc8+tc1*tc4*tc6*tc8)/(-pow(tc4,4)+3*tc3*pow(tc4,2)*tc5-pow(tc3,2)*pow(tc5,2)-2*tc2*tc4*pow(tc5,2)+tc1*pow(tc5,3)-2*pow(tc3,2)*tc4*tc6+2*tc2*pow(tc4,2)*tc6+2*tc2*tc3*tc5*tc6-2*tc1*tc4*tc5*tc6
        -pow(tc2,2)*pow(tc6,2)+tc1*tc3*pow(tc6,2)+pow(tc3,3)*tc7-2*tc2*tc3*tc4*tc7+tc1*pow(tc4,2)*tc7+pow(tc2,2)*tc5*tc7-tc1*tc3*tc5*tc7);
    b4=(-pow(tc5,4)+3*tc4*pow(tc5,2)*tc6-pow(tc4,2)*pow(tc6,2)-2*tc3*tc5*pow(tc6,2)+tc2*pow(tc6,3)-2*pow(tc4,2)*tc5*tc7+2*tc3*pow(tc5,2)*tc7+2*tc3*tc4*tc6*tc7-2*tc2*tc5*tc6*tc7-pow(tc3,2)*pow(tc7,2)+tc2*tc4*pow(tc7,2)+pow(tc4,3)*tc8-2*tc3*tc4*tc5*tc8
        +tc2*pow(tc5,2)*tc8+pow(tc3,2)*tc6*tc8-tc2*tc4*tc6*tc8)/(-pow(tc4,4)+3*tc3*pow(tc4,2)*tc5-pow(tc3,2)*pow(tc5,2)-2*tc2*tc4*pow(tc5,2)+tc1*pow(tc5,3)-2*pow(tc3,2)*tc4*tc6+2*tc2*pow(tc4,2)*tc6+2*tc2*tc3*tc5*tc6-2*tc1*tc4*tc5*tc6-pow(tc2,2)*pow(tc6,2)
        +tc1*tc3*pow(tc6,2)+pow(tc3,3)*tc7-2*tc2*tc3*tc4*tc7+tc1*pow(tc4,2)*tc7+pow(tc2,2)*tc5*tc7-tc1*tc3*tc5*tc7);
    m2=td2;
    m3=(-(td3*pow(td4,4))+3*pow(td3,2)*pow(td4,2)*td5+td2*pow(td4,3)*td5-pow(td3,3)*pow(td5,2)-4*td2*td3*td4*pow(td5,2)+pow(td2,2)*pow(td5,3)-2*pow(td3,3)*td4*td6+td2*td3*pow(td4,2)*td6+4*td2*pow(td3,2)*td5*td6-2*pow(td2,2)*td3*pow(td6,2)+pow(td3,4)*td7
        -td2*pow(td3,2)*td4*td7-pow(td2,2)*pow(td4,2)*td7+pow(td2,3)*td6*td7-td2*pow(td3,3)*td8+2*pow(td2,2)*td3*td4*td8-pow(td2,3)*td5*td8)/(-pow(td4,4)+3*td3*pow(td4,2)*td5-pow(td3,2)*pow(td5,2)-2*td2*td4*pow(td5,2)-2*pow(td3,2)*td4*td6+2*td2*pow(td4,2)*td6
        +2*td2*td3*td5*td6-pow(td2,2)*pow(td6,2)+pow(td3,3)*td7-2*td2*td3*td4*td7+pow(td2,2)*td5*td7);
    m4=(pow(td4,5)-4*td3*pow(td4,3)*td5+3*pow(td3,2)*td4*pow(td5,2)+3*td2*pow(td4,2)*pow(td5,2)-2*td2*td3*pow(td5,3)+3*pow(td3,2)*pow(td4,2)*td6-3*td2*pow(td4,3)*td6-2*pow(td3,3)*td5*td6-2*td2*td3*td4*td5*td6+pow(td2,2)*pow(td5,2)*td6+td2*pow(td3,2)*pow(td6,2)
        +2*pow(td2,2)*td4*pow(td6,2)-2*pow(td3,3)*td4*td7+4*td2*td3*pow(td4,2)*td7+2*td2*pow(td3,2)*td5*td7-4*pow(td2,2)*td4*td5*td7-2*pow(td2,2)*td3*td6*td7+pow(td2,3)*pow(td7,2)+pow(td3,4)*td8-3*td2*pow(td3,2)*td4*td8+pow(td2,2)*pow(td4,2)*td8
        +2*pow(td2,2)*td3*td5*td8-pow(td2,3)*td6*td8)/(pow(td4,4)-3*td3*pow(td4,2)*td5+pow(td3,2)*pow(td5,2)+2*td2*td4*pow(td5,2)+2*pow(td3,2)*td4*td6-2*td2*pow(td4,2)*td6-2*td2*td3*td5*td6+pow(td2,2)*pow(td6,2)-pow(td3,3)*td7+2*td2*td3*td4*td7-pow(td2,2)*td5*td7);
    n1=(-(pow(td4,3)*td5)+2*td3*td4*pow(td5,2)-td2*pow(td5,3)+td3*pow(td4,2)*td6-2*pow(td3,2)*td5*td6+td2*td3*pow(td6,2)-pow(td3,2)*td4*td7+td2*pow(td4,2)*td7+td2*td3*td5*td7-pow(td2,2)*td6*td7+pow(td3,3)*td8-2*td2*td3*td4*td8+pow(td2,2)*td5*td8)/(pow(td4,4)
        -3*td3*pow(td4,2)*td5+pow(td3,2)*pow(td5,2)+2*td2*td4*pow(td5,2)+2*pow(td3,2)*td4*td6-2*td2*pow(td4,2)*td6-2*td2*td3*td5*td6+pow(td2,2)*pow(td6,2)-pow(td3,3)*td7+2*td2*td3*td4*td7-pow(td2,2)*td5*td7);
    n2=(-(pow(td4,2)*pow(td5,2))+td3*pow(td5,3)+pow(td4,3)*td6-td2*pow(td5,2)*td6-td2*td4*pow(td6,2)-td3*pow(td4,2)*td7-pow(td3,2)*td5*td7+3*td2*td4*td5*td7+td2*td3*td6*td7-pow(td2,2)*pow(td7,2)+pow(td3,2)*td4*td8-td2*pow(td4,2)*td8-td2*td3*td5*td8
        +pow(td2,2)*td6*td8)/(-pow(td4,4)+3*td3*pow(td4,2)*td5-pow(td3,2)*pow(td5,2)-2*td2*td4*pow(td5,2)-2*pow(td3,2)*td4*td6+2*td2*pow(td4,2)*td6+2*td2*td3*td5*td6-pow(td2,2)*pow(td6,2)+pow(td3,3)*td7-2*td2*td3*td4*td7+pow(td2,2)*td5*td7);
    n3=(td4*pow(td5,3)-2*pow(td4,2)*td5*td6-td3*pow(td5,2)*td6+2*td3*td4*pow(td6,2)+td2*td5*pow(td6,2)+pow(td4,3)*td7-td2*pow(td5,2)*td7-pow(td3,2)*td6*td7-td2*td4*td6*td7+td2*td3*pow(td7,2)-td3*pow(td4,2)*td8+pow(td3,2)*td5*td8+td2*td4*td5*td8
        -td2*td3*td6*td8)/(-pow(td4,4)+3*td3*pow(td4,2)*td5-pow(td3,2)*pow(td5,2)-2*td2*td4*pow(td5,2)-2*pow(td3,2)*td4*td6+2*td2*pow(td4,2)*td6+2*td2*td3*td5*td6-pow(td2,2)*pow(td6,2)+pow(td3,3)*td7-2*td2*td3*td4*td7+pow(td2,2)*td5*td7);
    n4=(-pow(td5,4)+3*td4*pow(td5,2)*td6-pow(td4,2)*pow(td6,2)-2*td3*td5*pow(td6,2)+td2*pow(td6,3)-2*pow(td4,2)*td5*td7+2*td3*pow(td5,2)*td7+2*td3*td4*td6*td7-2*td2*td5*td6*td7-pow(td3,2)*pow(td7,2)+td2*td4*pow(td7,2)+pow(td4,3)*td8-2*td3*td4*td5*td8
        +td2*pow(td5,2)*td8+pow(td3,2)*td6*td8-td2*td4*td6*td8)/(-pow(td4,4)+3*td3*pow(td4,2)*td5-pow(td3,2)*pow(td5,2)-2*td2*td4*pow(td5,2)-2*pow(td3,2)*td4*td6+2*td2*pow(td4,2)*td6+2*td2*td3*td5*td6-pow(td2,2)*pow(td6,2)+pow(td3,3)*td7-2*td2*td3*td4*td7
        +pow(td2,2)*td5*td7);
    fprintf(fp,"# system file: %s\n",system);
    fprintf(fp,"# spin       : %f\n",spin);
    fprintf(fp,"# J1         : %f\n",j1);
    fprintf(fp,"# J2         : %f\n",j2);
    fprintf(fp,"# J3         : %f\n",j3);
    fprintf(fp,"# J4         : %f\n",j4);
    fprintf(fp,"# Susceptibility\n");
    fprintf(fp,"# c0         : 0\n");
    fprintf(fp,"# c1         : %.12e\n",tc1);
    fprintf(fp,"# c2         : %.12e\n",tc2);
    fprintf(fp,"# c3         : %.12e\n",tc3);
    fprintf(fp,"# c4         : %.12e\n",tc4);
    fprintf(fp,"# c5         : %.12e\n",tc5);
    fprintf(fp,"# c6         : %.12e\n",tc6);
    fprintf(fp,"# c7         : %.12e\n",tc7);
    fprintf(fp,"# c8         : %.12e\n",tc8);
    fprintf(fp,"# Susceptibility (Pade)\n");
    fprintf(fp,"# a0         : 0\n");
    fprintf(fp,"# a1         : %.12e\n",a1);
    fprintf(fp,"# a2         : %.12e\n",a2);
    fprintf(fp,"# a3         : %.12e\n",a3);
    fprintf(fp,"# a4         : %.12e\n",a4);
    fprintf(fp,"# b0         : 1\n");
    fprintf(fp,"# b1         : %.12e\n",b1);
    fprintf(fp,"# b2         : %.12e\n",b2);
    fprintf(fp,"# b3         : %.12e\n",b3);
    fprintf(fp,"# b4         : %.12e\n",b4);
    fprintf(fp,"# Internal Energy\n");
    fprintf(fp,"# e0         : 0\n");
    fprintf(fp,"# e1         : %.12e\n",te1);
    fprintf(fp,"# e2         : %.12e\n",te2);
    fprintf(fp,"# e3         : %.12e\n",te3);
    fprintf(fp,"# e4         : %.12e\n",te4);
    fprintf(fp,"# e5         : %.12e\n",te5);
    fprintf(fp,"# e6         : %.12e\n",te6);
    fprintf(fp,"# e7         : %.12e\n",te7);
    fprintf(fp,"# Specific Heat\n");
    fprintf(fp,"# d0         : 0\n");
    fprintf(fp,"# d1         : 0\n");
    fprintf(fp,"# d2 (-e1)   : %.12e\n",-te1);
    fprintf(fp,"# d3 (-2e2)  : %.12e\n",-2*te2);
    fprintf(fp,"# d4 (-3e3)  : %.12e\n",-3*te3);
    fprintf(fp,"# d5 (-4e4)  : %.12e\n",-4*te4);
    fprintf(fp,"# d6 (-5e5)  : %.12e\n",-5*te5);
    fprintf(fp,"# d7 (-6e6)  : %.12e\n",-6*te6);
    fprintf(fp,"# d8 (-7e7)  : %.12e\n",-7*te7);
    fprintf(fp,"# Specific Heat (Pade)\n");
    fprintf(fp,"# a0         : 0\n");
    fprintf(fp,"# a1         : 0\n");
    fprintf(fp,"# a2         : %.12e\n",m2);
    fprintf(fp,"# a3         : %.12e\n",m3);
    fprintf(fp,"# a4         : %.12e\n",m4);
    fprintf(fp,"# b0         : 1\n");
    fprintf(fp,"# b1         : %.12e\n",n1);
    fprintf(fp,"# b2         : %.12e\n",n2);
    fprintf(fp,"# b3         : %.12e\n",n3);
    fprintf(fp,"# b4         : %.12e\n",n4);
    fprintf(fp,"# T    Chi(8th order)    Chi(Pade[4,4])    U(7th order)    C/k(8th order)    C/k(Pade[4,4])\n");
    for(double i=intervall;i<ende;i+=intervall)
    {
        b=1/i;
        chi=tc1*b+tc2*pow(b,2)+tc3*pow(b,3)+tc4*pow(b,4)+tc5*pow(b,5)+tc6*pow(b,6)+tc7*pow(b,7)+tc8*pow(b,8);
        chip=(a1*b+a2*pow(b,2)+a3*pow(b,3)+a4*pow(b,4))/(1+b1*b+b2*pow(b,2)+b3*pow(b,3)+b4*pow(b,4));
        U=te1*b+te2*pow(b,2)+te3*pow(b,3)+te4*pow(b,4)+te5*pow(b,5)+te6*pow(b,6)+te7*pow(b,7);
        C=-te1*pow(b,2)-2*te2*pow(b,3)-3*te3*pow(b,4)-4*te4*pow(b,5)-5*te5*pow(b,6)-6*te6*pow(b,7)-7*te7*pow(b,8);
        Cp=(m2*pow(b,2)+m3*pow(b,3)+m4*pow(b,4))/(1+n1*b+n2*pow(b,2)+n3*pow(b,3)+n4*pow(b,4));
        fprintf(fp,"%f   %f   %f   %f   %f   %f\n",i,chi,chip,U,C,Cp);
    }
}
