#include <cstdlib>
#include <stdio.h>
#include <iostream>
#include <string.h>
#include "c_n.h"
#include "c_1.h"
#include "c_2.h"
#include "c_3.h"
#include "c_4.h"
#include "c_5.h"
#include "c_6.h"
#include "c_7.h"
#include "c_8.h"
#include "e_1.h"
#include "e_2.h"
#include "e_3.h"
#include "e_4.h"
#include "e_5.h"
#include "e_6.h"
#include "e_7.h"
#include "hte.h"

using namespace std;

int jladen(char *datei,int **J,int *N,int **neqp,int *nneqp);

int main(int argc, char *argv[])
{
    double spin,j1,j2,j3,j4,ende,intervall;
    int j1g=0,j2g=0,j3g=0,j4g=0,endeg=0,intervallg=0;
    char datei1[50],datei2[50];
    FILE *fp;
    int ausgabe=0,eingabe=0,sping=0,add=0,graph=0,details=0;
    for(int i=0;i<argc;i++)
    {
        if(strcmp(argv[i],"-s")==0)
        {
            sping=1;
            spin=atof(argv[i+1]);
        }
        if(strcmp(argv[i],"-i")==0)
        {
            strcpy(datei1,argv[i+1]);
            eingabe=1;
        }
        if(strcmp(argv[i],"-o")==0)
        {
            strcpy(datei2,argv[i+1]);
            ausgabe=1;
        }
        if(strcmp(argv[i],"-a")==0)
            add=1;
        if(strcmp(argv[i],"-g")==0)
            graph=1;
        if(strcmp(argv[i],"-j1")==0)
        {
            j1=atof(argv[i+1]);
            j1g=1;
        }
        if(strcmp(argv[i],"-j2")==0)
        {
            j2=atof(argv[i+1]);
            j2g=1;
        }
        if(strcmp(argv[i],"-j3")==0)
        {
            j3=atof(argv[i+1]);
            j3g=1;
        }
        if(strcmp(argv[i],"-j4")==0)
        {
            j4=atof(argv[i+1]);
            j4g=1;
        }
        if(strcmp(argv[i],"-tm")==0)
        {
            ende=atof(argv[i+1]);
            endeg=1;
        }
        if(strcmp(argv[i],"-dt")==0)
        {
            intervall=atof(argv[i+1]);
            intervallg=1;
        }
        if(strcmp(argv[i],"-d")==0)
            details=1;
    }
    if(eingabe==0)
    {
        // Hilfe ausgeben und beenden
        cout<<"hte -i input [-s spin] [-o output] [-a] [-w] [-d] [-g] [-tm Tmax] [-dt dT] [-j1 J1] [-j2 J2] [-j3 J3] [-j4 J4]\n";
        cout<<"input   : Name of the system file.\n";
        cout<<"spin    : Spin of the system, when not specified it is set to 0.5.\n";
        cout<<"output  : Name of the output file, when not specified it is set to out.dat.\n";
        cout<<"-a      : Append to a file. Writing operations append data at the end of the file. The file is created if it does not exist.\n";
        cout<<"-w      : Create an empty file for writing. If a file with the same name already exists its content is erased. (standard)\n";
        cout<<"-d      : Prints detailed results.\n";
        cout<<"-g      : Calculates the susceptibility for the temperature interval 0..Tmax in steps of dT.\n";
        cout<<"Tmax    : When not specified it is set to 100.\n";
        cout<<"dT      : When not specified it is set to 0.05\n";
        cout<<"J1/2/3/4: \n";
        return 0;
    }
    if(ausgabe==0)
    {
        if(add==1)
            fp=fopen("out.dat","a");
        else
            fp=fopen("out.dat","w");
    }
    else
    {
        if(add==1)
            fp=fopen(datei2,"a");
        else
            fp=fopen(datei2,"w");
    }
    if(sping==0)spin=0.5;
    if(j1g==0)j1=0;
    if(j2g==0)j2=0;
    if(j3g==0)j3=0;
    if(j4g==0)j4=0;
    if(endeg==0)ende=100;
    if(intervallg==0)intervall=0.05;
    CHTE chi(datei1,spin,fp);
    if(chi.showerror()==0)
    {
        if(graph==1)
            chi.berechnen(graph);
        else if(details==1)
            chi.berechnen(0);
        else
            chi.berechnen(2);
    }
    if(graph==1)
        chi.graph(ende,intervall,j1,j2,j3,j4);
    fclose(fp);
    return 0;
}
