#include <stdio.h>
#include <math.h>
#include "c_n.h"

void Cc_n::Init(int *J,int N, double spin,int *neqp,int nneqp,int NNmax,int *AnzahlNN,int *NN,FILE *fp)
{
    this->J=J;
    this->N=N;
    this->spin=spin;
    this->neqp=neqp;
    this->nneqp=nneqp;
    this->NNmax=NNmax;
    this->AnzahlNN=AnzahlNN;
    this->NN=NN;
    this->fp=fp;
}

void Cc_n::auswerten(int ergebnis,double *ci)
{
    int a=0,b=0,c=0,d=0;
    if(ergebnis!=0)
    {
        while(ergebnis%2==0)
        {
            ergebnis/=2;
            a++;
        }
        while(ergebnis%3==0)
        {
            ergebnis/=3;
            b++;
        }
        while(ergebnis%5==0)
        {
            ergebnis/=5;
            c++;
        }
        while(ergebnis%7==0)
        {
            ergebnis/=7;
            d++;
        }
        ci[a+b*MAXORDER+c*MAXORDER2+d*MAXORDER3]++;
    }
}

void Cc_n::ausgabe(char *titel,double *ci)
{
    int temp2=0;
    int a,b,c,d;
    fprintf(fp,"%s: ",titel);
    for(int i=0;i<MAXORDER4;i++)
    {
        if(ci[i]!=0)
        {
            if(temp2==1 && ci[i]>0)fprintf(fp,"+");
            d=i/MAXORDER3;
            c=(i-MAXORDER3*d)/MAXORDER2;
            b=(i-MAXORDER3*d-MAXORDER2*c)/MAXORDER;
            a=i-MAXORDER3*d-MAXORDER2*c-MAXORDER*b;
            if(ci[i]-(int)ci[i]!=0)
                fprintf(fp,"%.12e",ci[i]);
            else
                fprintf(fp,"%d",(int)ci[i]);
            if(a>0)
            {
                if(a>1)fprintf(fp,"J1^%d",a);
                else fprintf(fp,"J1");
            }
            if(b>0)
            {
                if(b>1)fprintf(fp,"J2^%d",b);
                else fprintf(fp,"J2");
            }
            if(c>0)
            {
                if(c>1)fprintf(fp,"J3^%d",c);
                else fprintf(fp,"J3");
            }
            if(d>0)
            {
                if(d>1)fprintf(fp,"J4^%d",d);
                else fprintf(fp,"J4");
            }
            temp2=1;
        }
    }
    if(temp2==0)fprintf(fp,"0");
    fprintf(fp,"\n");
}

void Cc_n::berechneGraph(int nummer,double faktor,int write)
{
    int i[8],j,l,m[7];
    int teiler=1;
    double ci[MAXORDER4];
    char titel[10];
    sprintf(titel,"G%d/N",nummer);
    for(j=0;j<MAXORDER4;ci[j]=0,j++);
    for(int k=0;k<nneqp;k++)
    {
        i[0]=neqp[k];
        for(m[0]=0;m[0]<AnzahlNN[i[0]];m[0]++)
        {
            i[1]=NN[i[0]*NNmax+m[0]];
            switch(nummer)
            {
            case 1:
                auswerten(J[i[0]+N*i[1]],ci);
                teiler=2;
                break;
            case 2:
                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]],ci);
                teiler=2;
                break;
            case 3:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 4:
                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]],ci);
                teiler=2;
                break;
            case 5:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 7:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]],ci);
                }
                teiler=3;
                break;
            case 8:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 9:
                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]],ci);
                teiler=2;
                break;
            case 10:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 12:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 13:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 14:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 15:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 16:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[1]+N*i[2]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 19:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 21:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]],ci);
                    }
                }
                teiler=4;
                break;
            case 22:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 23:
                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]],ci);
                teiler=2;
                break;
            case 24:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 26:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 27:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 28:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 29:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 30:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 33:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[1]],ci);
                    }
                }
                teiler=1;
                break;
            case 34:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 35:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 37:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 38:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 39:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[1] || i[4]==i[2] || i[4]==i[3])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 42:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 43:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 44:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 45:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 50:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[1] || i[4]==i[2])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 51:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 52:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 53:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[3])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 56:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=5;
                break;
            case 57:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[3])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 58:
                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]],ci);
                teiler=2;
                break;
            case 59:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 60:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 62:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 63:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 64:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]],ci);
                    }
                }
                teiler=1;
                break;
            case 65:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 68:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=m[1]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 69:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 70:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]],ci);
                }
                teiler=3;
                break;
            case 71:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 72:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 74:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 75:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]]*J[i[0]+N*i[1]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 76:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]],ci);
                    }
                }
                teiler=1;
                break;
            case 77:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=m[1]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[3]]*J[i[0]+N*i[2]]*J[i[2]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 79:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]],ci);
                    }
                }
                teiler=4;
                break;
            case 80:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 83:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[1] || i[4]==i[2])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=2;
                break;
            case 84:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=m[1]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]],ci);
                    }
                }
                teiler=4;
                break;
            case 86:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[1]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=6;
                break;
            case 87:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 89:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 90:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=m[1]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 91:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 93:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 94:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]],ci);
                    }
                }
                teiler=1;
                break;
            case 95:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 96:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 97:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 100:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]],ci);
                    }
                }
                teiler=1;
                break;
            case 101:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 102:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[1] || i[4]==i[2] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[1]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 104:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 108:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]],ci);
                    }
                }
                teiler=1;
                break;
            case 109:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[1] || i[4]==i[2])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[3]+N*i[4]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 110:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[1] || i[4]==i[2])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 111:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[1] || i[4]==i[2] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 112:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]],ci);
                    }
                }
                teiler=1;
                break;
            case 113:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[2]]*J[i[2]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 114:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 115:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[1] || i[4]==i[2] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 116:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[0] || i[4]==i[1] || i[4]==i[2])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 117:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[0] || i[4]==i[1] || i[4]==i[2])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 118:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[1] || i[4]==i[2] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[3]]*J[i[0]+N*i[2]]*J[i[3]+N*i[4]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 119:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 120:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[0] || i[4]==i[1] || i[4]==i[2])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[1]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 121:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[1] || i[4]==i[2])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 122:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]]*J[i[1]+N*i[3]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 123:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[0] || i[4]==i[1] || i[4]==i[2])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[3]]*J[i[0]+N*i[3]],ci);
                        }
                    }
                }
                teiler=2;
                break;
            case 125:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[0] || i[4]==i[1] || i[4]==i[2])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 126:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[0] || i[4]==i[1] || i[4]==i[2])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[3]]*J[i[0]+N*i[1]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 127:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[3]+N*i[4]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 128:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[1] || i[4]==i[2] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 129:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=m[1]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[2]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[2]]*J[i[2]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 134:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[2]+N*i[4]]*J[i[2]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 135:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 136:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[1] || i[4]==i[2])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 139:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 140:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 141:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[2]+N*i[3]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 143:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[0]];m[4]++)
                            {
                                i[5]=NN[i[0]*NNmax+m[4]];
                                if(i[5]==i[1] || i[5]==i[2] || i[5]==i[3] || i[5]==i[4])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[3]+N*i[4]]*J[i[1]+N*i[4]]*J[i[0]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 144:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 145:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=m[1]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 150:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                for(m[5]=0;m[5]<AnzahlNN[i[0]];m[5]++)
                                {
                                    i[6]=NN[i[0]*NNmax+m[5]];
                                    if(i[6]==i[4] || i[6]==i[3] || i[6]==i[2] || i[6]==i[1] || i[6]==i[5])
                                        continue;
                                    auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[0]+N*i[6]],ci);
                                }
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 155:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=m[1]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[4]]*J[i[0]+N*i[3]]*J[i[0]+N*i[2]]*J[i[2]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=2;
                break;
            case 156:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=m[1]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[4]]*J[i[0]+N*i[3]]*J[i[0]+N*i[2]]*J[i[2]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 157:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[1]];m[4]++)
                            {
                                i[5]=NN[i[1]*NNmax+m[4]];
                                if(i[5]==i[0] || i[5]==i[2] || i[5]==i[3] || i[5]==i[4])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[5]]*J[i[2]+N*i[5]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 158:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[0] || i[5]==i[2] || i[5]==i[3] || i[5]==i[1])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 159:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[0] || i[4]==i[1] || i[4]==i[2])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[0] || i[5]==i[1] || i[5]==i[2] || i[5]==i[3])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 160:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[1] || i[4]==i[2] || i[4]==i[3])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[2]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 161:
                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]],ci);
                teiler=2;
                break;
            case 162:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 163:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 164:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 165:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 166:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 167:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 168:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 169:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 170:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 171:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 172:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 173:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 174:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 175:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 176:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 177:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 178:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 179:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 180:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 181:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 182:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[3]],ci);
                        }
                    }
                }
                teiler=2;
                break;
            case 183:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 184:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 185:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 186:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 187:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 188:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=m[1]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 189:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 190:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 191:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 192:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 193:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[3]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 194:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 195:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 196:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 197:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 198:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 199:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 200:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 201:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 202:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 203:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[3]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 204:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 205:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[2]];m[4]++)
                            {
                                i[5]=NN[i[2]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[3] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[5]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 206:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 207:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 208:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 209:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 210:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 211:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 212:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[1]];m[3]++)
                        {
                            i[4]=NN[i[1]*NNmax+m[3]];
                            if(i[4]==i[0] || i[4]==i[2] || i[4]==i[3])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[4]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 213:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]]*J[i[3]+N*i[4]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 214:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 215:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=m[3]+1;m[4]<AnzahlNN[i[3]];m[4]++)
                            {
                                i[5]=NN[i[3]*NNmax+m[4]];
                                if(i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 216:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 217:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[2]];m[4]++)
                            {
                                i[5]=NN[i[2]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[3] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[5]]*J[i[2]+N*i[5]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 218:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 219:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[3]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 220:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 221:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 222:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 223:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 224:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[3]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 225:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]],ci);
                        }
                    }
                }
                teiler=2;
                break;
            case 226:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 227:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 228:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 229:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 230:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[0]];m[4]++)
                            {
                                i[5]=NN[i[0]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[3] || i[5]==i[2] || i[5]==i[1])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[5]]*J[i[0]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 231:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 232:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 233:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 234:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 235:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[0]];m[4]++)
                            {
                                i[5]=NN[i[0]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[3] || i[5]==i[2] || i[5]==i[1])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]]*J[i[0]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 236:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 237:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 238:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=m[1]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[1]+N*i[4]]*J[i[2]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=2;
                break;
            case 239:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=m[1]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 240:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[1]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 241:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 242:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[1]+N*i[4]]*J[i[2]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 243:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[2]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 244:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 245:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[3]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 246:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=2;
                break;
            case 247:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[3]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 248:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 249:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 250:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=2;
                break;
            case 251:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=m[1]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[2]];m[4]++)
                            {
                                i[5]=NN[i[2]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[3] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[5]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 252:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=m[1]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]]*J[i[2]+N*i[4]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 253:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[2]];m[4]++)
                            {
                                i[5]=NN[i[2]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[3] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[5]]*J[i[2]+N*i[5]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 254:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=m[3]+1;m[4]<AnzahlNN[i[3]];m[4]++)
                            {
                                i[5]=NN[i[3]*NNmax+m[4]];
                                if(i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 255:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 256:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 257:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 258:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 259:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 260:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 261:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 262:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 263:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 264:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[2]+N*i[3]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 265:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[1]];m[3]++)
                        {
                            i[4]=NN[i[1]*NNmax+m[3]];
                            if(i[4]==i[0] || i[4]==i[2] || i[4]==i[3])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[4]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[4]]*J[i[1]+N*i[2]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 266:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[2]+N*i[3]],ci);
                        }
                    }
                }
                teiler=2;
                break;
            case 267:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                        continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 268:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 269:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 270:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]]*J[i[4]+N*i[5]]*J[i[3]+N*i[4]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 271:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=m[1]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[1] || i[4]==i[3])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]]*J[i[2]+N*i[4]]*J[i[3]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 272:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 273:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[3]];m[4]++)
                            {
                                i[5]=NN[i[3]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[3]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 274:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[3]];m[4]++)
                            {
                                i[5]=NN[i[3]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[3]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 275:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 276:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 277:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 278:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 279:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[2]+N*i[5]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 280:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 281:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 282:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 283:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 284:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 285:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 286:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 287:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 288:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 289:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=m[1]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 290:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]]*J[i[1]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 291:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 292:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 293:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[2]+N*i[4]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 294:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[1]+N*i[4]]*J[i[2]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 295:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 296:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 297:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 298:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 299:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 300:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]]*J[i[1]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 301:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 302:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[1]];m[3]++)
                        {
                            i[4]=NN[i[1]*NNmax+m[3]];
                            if(i[4]==i[0] || i[4]==i[2] || i[4]==i[3])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[4]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 303:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 304:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=m[1]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 305:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 306:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[2]+N*i[4]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 307:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[5]]*J[i[3]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 308:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=m[1]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[0]];m[4]++)
                            {
                                i[5]=NN[i[0]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[3] || i[5]==i[2] || i[5]==i[1])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[4]]*J[i[2]+N*i[4]]*J[i[3]+N*i[4]]*J[i[0]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 309:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 310:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[0]];m[4]++)
                            {
                                i[5]=NN[i[0]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[4])
                                    continue;
                                for(m[5]=m[4]+1;m[5]<AnzahlNN[i[0]];m[5]++)
                                {
                                    i[6]=NN[i[0]*NNmax+m[5]];
                                    if(i[6]==i[4] || i[6]==i[3] || i[6]==i[2] || i[6]==i[1])
                                        continue;
                                    auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[5]]*J[i[0]+N*i[6]]*J[i[5]+N*i[6]],ci);
                                }
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 311:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[2]+N*i[4]]*J[i[2]+N*i[4]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 312:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=m[1]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[2]+N*i[4]]*J[i[3]+N*i[4]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 313:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[1]+N*i[4]]*J[i[2]+N*i[3]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=2;
                break;
            case 314:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=m[1]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[2]+N*i[4]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 315:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 316:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=m[1]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[2]+N*i[3]]*J[i[2]+N*i[4]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 317:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 318:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 319:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 320:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 321:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 322:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 323:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[1]];m[3]++)
                        {
                            i[4]=NN[i[1]*NNmax+m[3]];
                            if(i[4]==i[0] || i[4]==i[2] || i[4]==i[3])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[4]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[3]+N*i[4]]*J[i[1]+N*i[2]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 324:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[0] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=m[0]+1;m[4]<AnzahlNN[i[0]];m[4]++)
                            {
                                i[5]=NN[i[0]*NNmax+m[4]];
                                if(i[5]==i[2] || i[5]==i[3] || i[5]==i[4])
                                    continue;
                                for(m[5]=0;m[5]<AnzahlNN[i[0]];m[5]++)
                                {
                                    i[6]=NN[i[0]*NNmax+m[5]];
                                    if(i[6]==i[4] || i[6]==i[3] || i[6]==i[2] || i[6]==i[1] || i[6]==i[5])
                                        continue;
                                    auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[0]+N*i[5]]*J[i[2]+N*i[5]]*J[i[0]+N*i[6]],ci);
                                }
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 325:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[3]];m[4]++)
                            {
                                i[5]=NN[i[3]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[2]+N*i[5]]*J[i[3]+N*i[5]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 326:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]]*J[i[3]+N*i[4]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 327:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=m[1]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[1] || i[4]==i[3])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]]*J[i[2]+N*i[5]]*J[i[3]+N*i[4]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 328:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 329:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[3])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[0] || i[5]==i[3] || i[5]==i[2] || i[5]==i[1])
                                    continue;
                                for(m[5]=0;m[5]<AnzahlNN[i[0]];m[5]++)
                                {
                                    i[6]=NN[i[0]*NNmax+m[5]];
                                    if(i[6]==i[4] || i[6]==i[3] || i[6]==i[2] || i[6]==i[1] || i[6]==i[5])
                                        continue;
                                    auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]]*J[i[0]+N*i[6]]*J[i[0]+N*i[6]],ci);
                                }
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 330:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 331:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=m[2]+1;m[4]<AnzahlNN[i[0]];m[4]++)
                            {
                                i[5]=NN[i[0]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[2] || i[5]==i[1])
                                    continue;
                                for(m[5]=0;m[5]<AnzahlNN[i[5]];m[5]++)
                                {
                                    i[6]=NN[i[5]*NNmax+m[5]];
                                    if(i[6]==i[4] || i[6]==i[3] || i[6]==i[2] || i[6]==i[1] || i[6]==i[0])
                                        continue;
                                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[0]+N*i[5]]*J[i[5]+N*i[6]],ci);
                                }
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 332:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 333:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=2;
                break;
            case 334:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 335:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 336:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 337:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]]*J[i[3]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 338:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 339:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 340:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 341:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 342:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 343:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 344:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=m[1]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[0]+N*i[1]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]]*J[i[3]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 345:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=m[2]+1;m[4]<AnzahlNN[i[0]];m[4]++)
                            {
                                i[5]=NN[i[0]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[2] || i[5]==i[1])
                                    continue;
                                for(m[5]=0;m[5]<AnzahlNN[i[5]];m[5]++)
                                {
                                    i[6]=NN[i[5]*NNmax+m[5]];
                                    if(i[6]==i[4] || i[6]==i[3] || i[6]==i[2] || i[6]==i[1] || i[6]==i[0])
                                        continue;
                                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[0]+N*i[5]]*J[i[5]+N*i[6]]*J[i[4]+N*i[6]],ci);
                                }
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 346:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=m[1]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[3]+N*i[5]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]]*J[i[3]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 347:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]]*J[i[3]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 348:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]]*J[i[3]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 349:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[0]];m[4]++)
                            {
                                i[5]=NN[i[0]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[3] || i[5]==i[2] || i[5]==i[1])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[0]+N*i[5]]*J[i[2]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 350:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 351:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 352:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[0]];m[4]++)
                            {
                                i[5]=NN[i[0]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[4])
                                    continue;
                                for(m[5]=0;m[5]<AnzahlNN[i[0]];m[5]++)
                                {
                                    i[6]=NN[i[0]*NNmax+m[5]];
                                    if(i[6]==i[4] || i[6]==i[3] || i[6]==i[2] || i[6]==i[1] || i[6]==i[5])
                                        continue;
                                    auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[3]+N*i[4]]*J[i[0]+N*i[5]]*J[i[0]+N*i[6]]*J[i[0]+N*i[6]],ci);
                                }
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 353:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 354:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 355:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[3])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[0] || i[5]==i[2] || i[5]==i[1] || i[5]==i[3])
                                    continue;
                                for(m[5]=m[0]+1;m[5]<AnzahlNN[i[0]];m[5]++)
                                {
                                    i[6]=NN[i[0]*NNmax+m[5]];
                                    if(i[6]==i[4] || i[6]==i[3] || i[6]==i[2] || i[6]==i[5])
                                        continue;
                                    auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]]*J[i[3]+N*i[6]]*J[i[0]+N*i[6]],ci);
                                }
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 356:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]]*J[i[3]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 357:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 358:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 359:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 360:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[2]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 361:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[1] || i[4]==i[2] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                for(m[5]=0;m[5]<AnzahlNN[i[0]];m[5]++)
                                {
                                    i[6]=NN[i[0]*NNmax+m[5]];
                                    if(i[6]==i[4] || i[6]==i[3] || i[6]==i[2] || i[6]==i[1] || i[6]==i[5])
                                        continue;
                                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[0]+N*i[6]],ci);
                                }
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 362:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 363:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 364:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                for(m[5]=0;m[5]<AnzahlNN[i[0]];m[5]++)
                                {
                                    i[6]=NN[i[0]*NNmax+m[5]];
                                    if(i[6]==i[5] || i[6]==i[4] || i[6]==i[3] || i[6]==i[2] || i[6]==i[1])
                                        continue;
                                    auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[2]+N*i[5]]*J[i[0]+N*i[6]],ci);
                                }
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 365:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 366:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 367:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 368:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[1] || i[4]==i[2] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                for(m[5]=0;m[5]<AnzahlNN[i[0]];m[5]++)
                                {
                                    i[6]=NN[i[0]*NNmax+m[5]];
                                    if(i[6]==i[4] || i[6]==i[3] || i[6]==i[2] || i[6]==i[1] || i[6]==i[5])
                                        continue;
                                    auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[0]+N*i[6]]*J[i[0]+N*i[6]],ci);
                                }
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 369:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                for(m[5]=0;m[5]<AnzahlNN[i[5]];m[5]++)
                                {
                                    i[6]=NN[i[5]*NNmax+m[5]];
                                    if(i[6]==i[4] || i[6]==i[3] || i[6]==i[2] || i[6]==i[1] || i[6]==i[0])
                                        continue;
                                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[5]+N*i[6]],ci);
                                }
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 370:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[1] || i[4]==i[2] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                for(m[5]=0;m[5]<AnzahlNN[i[0]];m[5]++)
                                {
                                    i[6]=NN[i[0]*NNmax+m[5]];
                                    if(i[6]==i[4] || i[6]==i[3] || i[6]==i[2] || i[6]==i[1] || i[6]==i[5])
                                        continue;
                                    auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[0]+N*i[6]],ci);
                                }
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 371:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                for(m[5]=0;m[5]<AnzahlNN[i[5]];m[5]++)
                                {
                                    i[6]=NN[i[5]*NNmax+m[5]];
                                    if(i[6]==i[4] || i[6]==i[3] || i[6]==i[2] || i[6]==i[1] || i[6]==i[0])
                                        continue;
                                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]]*J[i[5]+N*i[6]],ci);
                                }
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 372:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=m[0]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[3])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                for(m[5]=0;m[5]<AnzahlNN[i[5]];m[5]++)
                                {
                                    i[6]=NN[i[5]*NNmax+m[5]];
                                    if(i[6]==i[4] || i[6]==i[3] || i[6]==i[2] || i[6]==i[1] || i[6]==i[0])
                                        continue;
                                    auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]]*J[i[5]+N*i[6]]*J[i[3]+N*i[6]],ci);
                                }
                            }
                        }
                    }
                }
                teiler=7;
                break;
            case 373:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[0] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[1] || i[4]==i[2] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                for(m[5]=0;m[5]<AnzahlNN[i[5]];m[5]++)
                                {
                                    i[6]=NN[i[5]*NNmax+m[5]];
                                    if(i[6]==i[4] || i[6]==i[3] || i[6]==i[2] || i[6]==i[1] || i[6]==i[0])
                                        continue;
                                    for(m[6]=0;m[6]<AnzahlNN[i[0]];m[6]++)
                                    {
                                        i[7]=NN[i[0]*NNmax+m[6]];
                                        if(i[7]==i[5] || i[7]==i[4] || i[7]==i[3] || i[7]==i[2] || i[7]==i[1] || i[7]==i[6])
                                            continue;
                                        auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[5]+N*i[6]]*J[i[0]+N*i[7]],ci);
                                    }
                                }
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 374:
                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]],ci);
                teiler=2;
                break;
            case 375:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 376:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 377:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 378:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 379:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 380:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 381:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 382:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 383:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 384:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 385:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 386:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 387:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]],ci);
                }
                teiler=1;
                break;
            case 388:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 389:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 390:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 391:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 392:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 393:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 394:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 395:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[1]+N*i[3]]*J[i[1]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 396:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 397:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 398:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 399:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=m[1]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 400:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 401:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 402:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=2;
                break;
            case 403:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 404:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 405:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 406:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 407:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 408:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 409:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 410:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 411:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=m[1]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[1]+N*i[4]]*J[i[2]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=2;
                break;
            case 412:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 413:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] ||i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 414:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 415:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 416:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 417:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[1]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 418:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[1]+N*i[3]]*J[i[1]+N*i[3]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 419:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 420:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 421:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 422:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[2]+N*i[5]]*J[i[1]+N*i[3]]*J[i[1]+N*i[3]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 423:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 424:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 425:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 426:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 427:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 428:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 429:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[1]+N*i[4]]*J[i[2]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 430:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=m[3]+1;m[4]<AnzahlNN[i[3]];m[4]++)
                            {
                                i[5]=NN[i[3]*NNmax+m[4]];
                                if(i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 431:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 432:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 433:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 434:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 435:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 436:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 437:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 438:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 439:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]],ci);
                    }
                }
                teiler=4;
                break;
            case 440:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 441:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=m[1]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 442:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[0]];m[4]++)
                            {
                                i[5]=NN[i[0]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[3] || i[5]==i[2] || i[5]==i[1])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]]*J[i[0]+N*i[5]]*J[i[0]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 443:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=m[1]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 444:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[1]+N*i[2]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=2;
                break;
            case 445:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[3]+N*i[4]]*J[i[1]+N*i[4]],ci);
                        }
                    }
                }
                teiler=8;
                break;
            case 446:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]]*J[i[3]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 447:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] ||i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 448:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] ||i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 449:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 450:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[1]+N*i[3]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 451:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[1]+N*i[3]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 452:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[1]+N*i[3]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 453:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[1]+N*i[3]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 454:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] ||i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 455:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[1]+N*i[3]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 456:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[3]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 457:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[3]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 458:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[0]];m[4]++)
                            {
                                i[5]=NN[i[0]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[3] || i[5]==i[2] || i[5]==i[1])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[2]+N*i[3]]*J[i[0]+N*i[5]]*J[i[0]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 459:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[0]];m[4]++)
                            {
                                i[5]=NN[i[0]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[3] || i[5]==i[2] || i[5]==i[1])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[1]+N*i[3]]*J[i[2]+N*i[4]]*J[i[0]+N*i[5]]*J[i[0]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 460:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[1]+N*i[3]]*J[i[2]+N*i[4]]*J[i[2]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 461:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 462:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 463:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=2;
                break;
            case 464:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 465:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 466:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 467:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 468:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]]*J[i[1]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 469:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 470:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]]*J[i[1]+N*i[3]],ci);
                    }
                }
                teiler=1;
                break;
            case 471:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 472:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[4]]*J[i[2]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 473:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[1]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 474:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]]*J[i[1]+N*i[3]],ci);
                    }
                }
                teiler=4;
                break;
            case 475:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 476:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]]*J[i[1]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 477:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[0]];m[4]++)
                            {
                                i[5]=NN[i[0]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[3] || i[5]==i[2] || i[5]==i[1])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[5]]*J[i[0]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 478:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[1]+N*i[4]]*J[i[2]+N*i[4]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=2;
                break;
            case 479:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]]*J[i[1]+N*i[4]]*J[i[2]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 480:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 481:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[1]+N*i[3]]*J[i[2]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 482:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 483:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]]*J[i[1]+N*i[3]],ci);
                    }
                }
                teiler=2;
                break;
            case 484:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[1]+N*i[3]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 485:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]]*J[i[1]+N*i[3]]*J[i[1]+N*i[3]],ci);
                    }
                }
                teiler=4;
                break;
            case 486:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 487:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[1]+N*i[4]]*J[i[1]+N*i[4]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 488:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[1]+N*i[3]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 489:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 490:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 491:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=m[3]+1;m[4]<AnzahlNN[i[0]];m[4]++)
                            {
                                i[5]=NN[i[0]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[0]+N*i[5]]*J[i[0]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 492:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]]*J[i[3]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 493:
                for(m[1]=0;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 494:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    if(i[2]==i[1])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[2]+N*i[3]]*J[i[2]+N*i[3]]*J[i[1]+N*i[3]]*J[i[1]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 495:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[1]+N*i[2]]*J[i[1]+N*i[4]]*J[i[2]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 496:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=m[1]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[1]+N*i[5]]*J[i[2]+N*i[5]]*J[i[3]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 497:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=m[2]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 498:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[1]+N*i[4]]*J[i[2]+N*i[3]]*J[i[2]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=2;
                break;
            case 499:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[1]+N*i[3]]*J[i[2]+N*i[4]]*J[i[2]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 500:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[2]+N*i[5]]*J[i[1]+N*i[3]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 501:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[1]+N*i[3]]*J[i[1]+N*i[3]]*J[i[2]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 502:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]]*J[i[2]+N*i[4]]*J[i[2]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 503:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 504:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 505:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 506:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 507:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 508:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[0]];m[4]++)
                            {
                                i[5]=NN[i[0]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[3] || i[5]==i[2] || i[5]==i[1])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]]*J[i[0]+N*i[5]]*J[i[0]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 509:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[0]];m[4]++)
                            {
                                i[5]=NN[i[0]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[3] || i[5]==i[2] || i[5]==i[1])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[0]+N*i[5]]*J[i[0]+N*i[5]]*J[i[2]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 510:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[1]+N*i[3]]*J[i[2]+N*i[4]]*J[i[2]+N*i[4]],ci);
                        }
                    }
                }
                teiler=1;
                break;
            case 511:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[0]];m[4]++)
                            {
                                i[5]=NN[i[0]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[3] || i[5]==i[2] || i[5]==i[1])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]]*J[i[0]+N*i[5]]*J[i[0]+N*i[5]]*J[i[0]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 512:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[0]];m[4]++)
                            {
                                i[5]=NN[i[0]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[3] || i[5]==i[2] || i[5]==i[1])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[0]+N*i[5]]*J[i[0]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 513:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[0]];m[4]++)
                            {
                                i[5]=NN[i[0]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[3] || i[5]==i[2] || i[5]==i[1])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]]*J[i[2]+N*i[4]]*J[i[0]+N*i[5]]*J[i[0]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 514:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[0]];m[4]++)
                            {
                                i[5]=NN[i[0]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[3] || i[5]==i[2] || i[5]==i[1])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[2]+N*i[4]]*J[i[0]+N*i[5]]*J[i[0]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 515:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=m[2]+1;m[4]<AnzahlNN[i[0]];m[4]++)
                            {
                                i[5]=NN[i[0]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[2] || i[5]==i[1])
                                    continue;
                                for(m[5]=0;m[5]<AnzahlNN[i[5]];m[5]++)
                                {
                                    i[6]=NN[i[5]*NNmax+m[5]];
                                    if(i[6]==i[4] || i[6]==i[3] || i[6]==i[2] || i[6]==i[1] || i[6]==i[0])
                                        continue;
                                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[0]+N*i[5]]*J[i[5]+N*i[6]]*J[i[4]+N*i[6]],ci);
                                }
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 516:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=m[3]+1;m[4]<AnzahlNN[i[0]];m[4]++)
                            {
                                i[5]=NN[i[0]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1])
                                    continue;
                                for(m[5]=0;m[5]<AnzahlNN[i[5]];m[5]++)
                                {
                                    i[6]=NN[i[5]*NNmax+m[5]];
                                    if(i[6]==i[4] || i[6]==i[3] || i[6]==i[2] || i[6]==i[1] || i[6]==i[0])
                                        continue;
                                    auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[3]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[0]+N*i[5]]*J[i[4]+N*i[6]]*J[i[5]+N*i[6]],ci);
                                }
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 517:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[1]+N*i[5]]*J[i[2]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 518:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[1]+N*i[4]]*J[i[2]+N*i[3]]*J[i[2]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=4;
                break;
            case 519:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[0]];m[4]++)
                            {
                                i[5]=NN[i[0]*NNmax+m[4]];
                                if(i[5]==i[4] || i[5]==i[3] || i[5]==i[2] || i[5]==i[1])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[0]+N*i[5]]*J[i[2]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 520:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[2]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 521:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[2]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 522:
                for(m[1]=m[0]+1;m[1]<AnzahlNN[i[0]];m[1]++)
                {
                    i[2]=NN[i[0]*NNmax+m[1]];
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2] || i[4]==i[1])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[0]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[4]]*J[i[3]+N*i[5]]*J[i[3]+N*i[5]]*J[i[4]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 523:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[2]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 524:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2] || i[3]==i[1])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[2]+N*i[5]],ci);
                            }
                        }
                    }
                }
                teiler=2;
                break;
            case 525:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=m[0]+1;m[2]<AnzahlNN[i[0]];m[2]++)
                    {
                        i[3]=NN[i[0]*NNmax+m[2]];
                        if(i[3]==i[2])
                            continue;
                        for(m[3]=0;m[3]<AnzahlNN[i[3]];m[3]++)
                        {
                            i[4]=NN[i[3]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[1] || i[4]==i[0])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                for(m[5]=0;m[5]<AnzahlNN[i[0]];m[5]++)
                                {
                                    i[6]=NN[i[0]*NNmax+m[5]];
                                    if(i[6]==i[5] || i[6]==i[4] || i[6]==i[3] || i[6]==i[2] || i[6]==i[1])
                                        continue;
                                    auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[0]+N*i[3]]*J[i[3]+N*i[4]]*J[i[4]+N*i[5]]*J[i[2]+N*i[5]]*J[i[0]+N*i[6]]*J[i[0]+N*i[6]],ci);
                                }
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 526:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=m[0]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[2] || i[4]==i[3])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                for(m[5]=0;m[5]<AnzahlNN[i[5]];m[5]++)
                                {
                                    i[6]=NN[i[5]*NNmax+m[5]];
                                    if(i[6]==i[4] || i[6]==i[3] || i[6]==i[2] || i[6]==i[1] || i[6]==i[0])
                                        continue;
                                    auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]]*J[i[5]+N*i[6]]*J[i[3]+N*i[6]]*J[i[3]+N*i[6]],ci);
                                }
                            }
                        }
                    }
                }
                teiler=1;
                break;
            case 527:
                for(m[1]=0;m[1]<AnzahlNN[i[1]];m[1]++)
                {
                    i[2]=NN[i[1]*NNmax+m[1]];
                    if(i[2]==i[0])
                        continue;
                    for(m[2]=0;m[2]<AnzahlNN[i[2]];m[2]++)
                    {
                        i[3]=NN[i[2]*NNmax+m[2]];
                        if(i[3]==i[1] || i[3]==i[0])
                            continue;
                        for(m[3]=m[0]+1;m[3]<AnzahlNN[i[0]];m[3]++)
                        {
                            i[4]=NN[i[0]*NNmax+m[3]];
                            if(i[4]==i[3] || i[4]==i[2])
                                continue;
                            for(m[4]=0;m[4]<AnzahlNN[i[4]];m[4]++)
                            {
                                i[5]=NN[i[4]*NNmax+m[4]];
                                if(i[5]==i[3] || i[5]==i[2] || i[5]==i[1] || i[5]==i[0])
                                    continue;
                                for(m[5]=0;m[5]<AnzahlNN[i[5]];m[5]++)
                                {
                                    i[6]=NN[i[5]*NNmax+m[5]];
                                    if(i[6]==i[4] || i[6]==i[3] || i[6]==i[2] || i[6]==i[1] || i[6]==i[0])
                                        continue;
                                    for(m[6]=0;m[6]<AnzahlNN[i[6]];m[6]++)
                                    {
                                        i[7]=NN[i[6]*NNmax+m[6]];
                                        if(i[7]==i[5] || i[7]==i[4] || i[7]==i[3] || i[7]==i[2] || i[7]==i[1] || i[7]==i[0])
                                            continue;
                                        auswerten(J[i[0]+N*i[1]]*J[i[1]+N*i[2]]*J[i[2]+N*i[3]]*J[i[0]+N*i[4]]*J[i[4]+N*i[5]]*J[i[5]+N*i[6]]*J[i[6]+N*i[7]]*J[i[3]+N*i[7]],ci);
                                    }
                                }
                            }
                        }
                    }
                }
                teiler=8;
                break;
            }
        }
    }
    for(j=0;j<MAXORDER4;ci[j]/=(teiler*nneqp),j++);
    if(write==0)ausgabe(titel,ci);
    for(j=0;j<MAXORDER4;Ji[j]+=faktor*ci[j],j++);
}

double Cc_n::punkt(double j1,double j2,double j3,double j4)
{
    double temp=0;
    int a,b,c,d;
    for(int i=0;i<MAXORDER4;i++)
    {
        if(Ji[i]!=0)
        {
            d=i/MAXORDER3;
            c=(i-MAXORDER3*d)/MAXORDER2;
            b=(i-MAXORDER3*d-MAXORDER2*c)/MAXORDER;
            a=i-MAXORDER3*d-MAXORDER2*c-MAXORDER*b;
            temp+=Ji[i]*pow(j1,a)*pow(j2,b)*pow(j3,c)*pow(j4,d);
        }
    }
    return temp;
}

void Cc_n::specheat(int order)
{
    int temp2=0;
    double temp3;
    int a,b,c,d;
    fprintf(fp,"d%d/N: ",order);
    for(int i=0;i<MAXORDER4;i++)
    {
        if(Ji[i]!=0)
        {
            temp3=-Ji[i]*(order-1);
            if(temp2==1 && temp3>0)fprintf(fp,"+");
            d=i/MAXORDER3;
            c=(i-MAXORDER3*d)/MAXORDER2;
            b=(i-MAXORDER3*d-MAXORDER2*c)/MAXORDER;
            a=i-MAXORDER3*d-MAXORDER2*c-MAXORDER*b;
            if(temp3-(int)temp3!=0)
                fprintf(fp,"%.12e",temp3);
            else
                fprintf(fp,"%d",(int)temp3);
            if(a>0)
            {
                if(a>1)fprintf(fp,"J1^%d",a);
                else fprintf(fp,"J1");
            }
            if(b>0)
            {
                if(b>1)fprintf(fp,"J2^%d",b);
                else fprintf(fp,"J2");
            }
            if(c>0)
            {
                if(c>1)fprintf(fp,"J3^%d",c);
                else fprintf(fp,"J3");
            }
            if(d>0)
            {
                if(d>1)fprintf(fp,"J4^%d",d);
                else fprintf(fp,"J4");
            }
            temp2=1;
        }
    }
    if(temp2==0)fprintf(fp,"0");
    fprintf(fp,"\n");
}
